//!
//! @file adc.c,v
//!
//! Copyright (c) 2006 Atmel.
//!
//! @brief Ɠǂݍ݂A/Dϊ֐
//!
//! @version 1.4
//!

//_____ ݸٰ ________________________________________________________________
#include "config.h"
#include "inavr.h"
#include "adc.h"

//_____ ϸ ____________________________________________________________________


//_____ ` ___________________________________________________________________
#pragma vector = ADC_vect
__interrupt void Read_Measure(void);

//_____ 錾 ___________________________________________________________________
volatile U8   Flag_IT_ADC = 0 ;

//! @brief A/Dϊ̏
//!
//! @param	Ȃ
//! @pre	Ȃ
//! @return	Ȃ
//!/
void ADC_Init(void)
{
  /* ޼ٓ͋֎~ڼ޽0 */
  DIDR0 =   (0<<ADC7D) \
		  | (0<<ADC6D ) \
		  | (0<<ADC5D ) \
		  | (0<<ADC4D ) \
		  | (0<<ADC3D ) \
		  | (0<<ACMPM ) \
		  | (0<<ADC2D ) \
		  | (0<<ACMP2D) \
		  | (0<<ADC1D ) \
		  | (0<<ADC0D ) \
  ;

  /* ޼ٓ͋֎~ڼ޽ 1 */
  DIDR1 =   (0<<ACMP0D) \
		  | (1<<AMP0PD) /* AMP0޼ٓ͋֎~ */ \
		  | (1<<AMP0ND) /* AMP0޼ٓ͋֎~ */ \
		  | (0<<ADC10D) \
		  | (0<<ACMP1D) \
		  | (0<<ADC9D)  \
		  | (1<<AMP1PD) /* AMP1޼ٓ͋֎~ */ \
		  | (0<<ADC8D)  \
		  | (1<<AMP1ND) /* AMP1޼ٓ͋֎~ */ \
  ;

  /* 0 */
  AMP0CSR =   (1 <<AMP0EN) /* 0 */ \
			| (0 <<AMP0IS) \
			| (AMP_GAIN_5 <<AMP0G0) \
			| (AMP_TRIG_ON_PSC0 <<AMP0TS0) \
  ;

  /* 1 */
  AMP1CSR =   (1 <<AMP1EN) /* 1 */ \
			| (0 <<AMP1IS) \
			| (AMP_GAIN_5 <<AMP1G0) \
			| (AMP_TRIG_ON_PSC0 <<AMP1TS0) \
  ;

  /* A/Dϊ평 */
  ADMUX =    (ADC_VREF_INTERNAL <<REFS0) \
		   | (0 <<ADLAR) \
		   | (ADC_INPUT_AMP1 <<MUX0) /* ͑I */ \
  ;

  ADCSRB =   (1<<ADHSM)  /*  */ \
		   | (0<<ADASCR) /* AT90PWM3BŖgp */ \
		   | (ADC_TRIG_SRC_FREE_RUNNING <<ADTS0) \
  ;

  ADCSRA =   (1<<ADEN)  /* A/Dϊ틖 */ \
		   | (0<<ADSC)  \
		   | (0<<ADATE) \
		   | (1<<ADIE)  /* 荞݋ */ \
		   | (ADC_PRESCALER_16 <<ADPS0) \
  ;
}

//! @brief A/DϊJn
//!
//! @param	Ȃ
//! @pre	Ȃ
//! @return	Ȃ
//!/
void   Start_ADC(void)
{
  ADCSRA =   (1<<ADEN)  /* A/Dϊ틖 */ \
		   | (1<<ADSC)  /* ϊJn */ \
		   | (0<<ADATE) \
		   | (1<<ADIE)  /* 荞݋ */ \
		   | (ADC_PRESCALER_16 <<ADPS0) \
  ;
}

//! @brief A/Dϊʎ擾
//!
//! @param	Ȃ
//! @pre	Ȃ
//! @return	16ޯČ
//!/
S16 read_acquisition(void)
{
  Union16     resultADC ;

  LSB(resultADC) = ADCL ;	// A/Dϊo͂10ޯĕ\܂B
  MSB(resultADC) = ADCH ;

  return (resultADC.w) ;
}

//! @brief ϊIADC׸ނݒ
//!
//! @param	Ȃ
//! @pre	Ȃ
//! @return	Ȃ
//!/
__interrupt void Read_Measure(void)
{
  Flag_IT_ADC=1;
}

