//! @file adc_drv.h,v
//!
//! Copyright (c) 2004 Atmel.
//!
//! 쌠ʒmɂĂlicense.txţقǂłB
//!
//! @brief ̧ق͈ȉ̊֐ײ؂̌^ϸۂ܂݂܂B
//!
//! @version 1.5.2.10 mc100_bldc_sinus_0_0_5
//!
//! @todo
//! @bug

#ifndef ADC_DRV_H
#define ADC_DRV_H

//_____ ݸٰ _______________________________________________________________

#ifndef ADHSM
#define ADHSM	7
#endif

//! @defgroup ADC_module A/Dϊ핔
//! A/Dϊ핔
//! @{
//_____ ϸ ___________________________________________________________________

  //! @defgroup ADC_macros A/Dϊϸ
  //! iA/Dϊ̎gpϸ
  //! @{

	//! @defgroup Turn_on_adc A/DϊON
	//! A/DϊON
	//! @{
#define Enable_adc()							(ADCSRA |= (1<<ADEN))
	//! @}

	//! @defgroup ADC_alignement_configuration A/Dϊʐ`Ԑݒ
	//! A/Dϊʐ`Ԑݒ
	//! @{
#define Right_adjust_adc_result()				(ADMUX  &= ~(1<<ADLAR))
#define Left_adjust_adc_result()				(ADMUX  |=  (1<<ADLAR))
	//! @}

	//! @defgroup ADC_high_speed_mode_configuration A/Dϊ`Ԑݒ
	//! `ԐݒȀꍇA/Dϊg200kHzȂ܂B
	//! @{
#define Enable_adc_high_speed_mode()			(ADCSRB |=  (1<<ADHSM))
#define Disable_adc_high_speed_mode()			(ADCSRB &= ~(1<<ADHSM))
	//! @}

	//! @defgroup ADC_vref_configuration A/DϊVref`Ԑݒ
	//! Vref`Ԑݒ
	//! @{
#define Enable_internal_vref()					(ADMUX  |=  ((1<<REFS1)|(1<<REFS0)) )
#define Enable_external_vref()					(ADMUX  &= ~((1<<REFS1)|(1<<REFS0)) )
#define Enable_vcc_vref()						(ADMUX  &= ~(1<<REFS1),\
												 ADMUX  |=  (1<<REFS0) )
	//! @}

	//! @defgroup ADC_it_configuration A/Dϊ荞݌`Ԑݒ
	//! A/Dϊ荞݌`Ԑݒ
	//! @{
#define Enable_all_it()							(SREG   |=  (0x80) )
#define Disable_all_it()						(SREG   &= ~(0x80) )
#define Enable_adc_it()							(ADCSRA |=  (1<<ADIE) )
#define Disable_adc_it()						(ADCSRA &= ~(1<<ADIE) )
#define Clear_adc_flag()						(ADCSRA &=  (1<<ADIF) )
	//! @}

	//! @defgroup ADC_prescaler_configuration A/DϊOu`Ԑݒ
	//! A/DϊOu`Ԑݒ
	//! @{
#define Set_prescaler(prescaler)				(ADCSRA &= ~((1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)),\
												 ADCSRA |=  (prescaler) )
	//! @}

	//! @defgroup ADC_channel_selection A/DϊّI
	//! ϊׂA/DϊّI
	//! @{
#define Clear_adc_mux()							(ADMUX  &= ~((1<<MUX3)|(1<<MUX2)|(1<<MUX1)|(1<<MUX0)) )
#define Select_adc_channel(channel)				(Clear_adc_mux(), ADMUX |= (channel) )
	//! @}

	//! @defgroup ADC_start_conversion A/DϊJn
	//! A/DϊJn
	//! @{

	  //! @defgroup ADC_start_normal_conversion A/Dϊʏϊ
	  //! `ԂŕϊJn
	  //! @{
#define Start_conv()							(ADCSRA |= (1<<ADSC) )
#define Start_conv_channel(channel)				(Select_adc_channel(channel), Start_conv() )
#define Start_amplified_conv()					(ADCSRB |= (1<<ADASCR) )
#define Stop_amplified_conv()					(ADCSRB &= ~(1<<ADASCR) )
#define Start_amplified_conv_channel(channel)	(Select_adc_channel(channel), Start_amplified_conv() )
	  //! @}

	  //! @defgroup ADC_start_idle_conversion A/DϊٕϊJn
	  //! Gጸ`ԂA/DϊJn
	  //! @{
#define Start_conv_idle()						(SMCR   |=  (1<<SM0)|(1<<SE) )
#define Start_conv_idle_channel(channel)		(Select_adc_channel(channel), Start_conv_idle() )
#define Clear_sleep_mode()						(SMCR   &= ~(1<<SM0)|(1<<SE) )
	  //! @}
	//! @}

	//! @defgroup ADC_get_x_bits_result A/DϊnޯĂ̌ʎ擾
	//! nޯĂA/Dϊʎ擾
	//! @{
#define Adc_get_8_bits_result()					((U8)(ADCH))
#define Adc_get_10_bits_result()				((U16)(ADCL+((U16)(ADCH<<8))))
	//! @}

	//! @defgroup Turn_off_adc A/DϊOFF
	//! A/DϊOFF
	//! @{
#define Disable_adc()							(ADCSRA &= ~(1<<ADEN))
	//! @}

	//! @defgroup ϊIۂ̌
	//! ϊ󋵌
	//! @{
#define Is_adc_conv_finished()					((ADCSRA &  (1<<ADIF)) ? TRUE : FALSE)
#define Is_adc_conv_not_finished()				((ADCSRA | ~(1<<ADIF)) ? TRUE : FALSE)
	//! @}
  //! @}

//_____ ` __________________________________________________________________

//_____ ֐ __________________________________________________________________
  //! @defgroup ADC_low_level_functions A/Dϊʊ֐
  //! A/Dϊʊ֐
  //! @{

//! A/Dϊ`Ԑݒ`lɏ]A/Dϊ`Ԑݒ
//! DIDR0DIDR1ڼ޽ɂı۸ޓ͂Ƃĕϊ߰ĂIȂ΂
//! ȂƂɒӂĂB
//!
void init_adc(void);
  //! @}
//! @}

#endif  // ADC_DRV_H
